# This file is a template, and might need editing before it works on your project.
# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/python/tags/
image: python:3.8

stages:
  - Static Analysis
  - Unittests
  - Build

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
cache:
  paths:
    - .cache/pip
    - venv/

before_script:
  - python -V  # Print out python version for debugging
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate


flake8:
  stage: Static Analysis
  script:
    - pip install flake8
    - flake8 --max-line-length=120 --max-complexity 10 flask_microservice_commons

pylint:
  stage: Static Analysis
  allow_failure: true
  before_script:
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate
    - pip install -r requirements.txt
    - pip install pylint pylint-fail-under
  script:
    - pylint-fail-under --fail_under 8.0 --max-line-length=120 -d W1202,E1101,C0103,C0330 flask_microservice_commons

test:
  stage: Unittests
  script:
    - pip install coverage
    - coverage run --source=flask_microservice_commons setup.py test
    - coverage report

build:
  stage: Build
  script:
    - python setup.py bdist_wheel
    # an alternative approach is to install and run:
    # - pip install dist/*
    # run the command here
  artifacts:
    paths:
      - dist/*.whl
  only:
    - tags

pages:
  stage: Build
  script:
    - pip install -r requirements.txt
    - pip install sphinx sphinx-rtd-theme
    - cd docs ; make html
    - mv build/html/ ../public/
  artifacts:
    paths:
      - public
  only:
    - master
